<?php
// ---------------------------------------------------------------------------
// $Id: ModelAction.class.php,v 1.5 2004/12/19 14:55:27 dankert Exp $
// ---------------------------------------------------------------------------
// OpenRat Content Management System
// Copyright (C) 2002-2004 Jan Dankert, cms@jandankert.de
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// ---------------------------------------------------------------------------
// $Log: ModelAction.class.php,v $
// Revision 1.5  2004/12/19 14:55:27  dankert
// Anpassung von urls
//
// Revision 1.4  2004/12/13 22:17:51  dankert
// URL-Korrektur
//
// Revision 1.3  2004/05/07 21:37:31  dankert
// Url ?ber Html::url erzeugen
//
// Revision 1.2  2004/05/02 14:49:37  dankert
// Einf?gen package-name (@package)
//
// Revision 1.1  2004/04/24 15:14:52  dankert
// Initiale Version
//
// ---------------------------------------------------------------------------


/**
 * Action-Klasse zum Bearbeiten eines Projetmodells
 * @author $Author: dankert $
 * @version $Revision: 1.5 $
 * @package openrat.actions
 */
class ModelAction extends Action
{
	var $defaultSubAction = 'listing';
	var $model;


	function ModelAction()
	{
		if	( $this->getRequestId() != 0 )
		{
			$this->model = new Model( $this->getRequestId() );
			$this->model->load();
		}
		
		$this->project = Session::getProject();
	}


	function add()
	{
		$model = new Model();
		$model->projectid = $this->project->projectid;
		$model->name      = $this->getRequestVar('name');
		$model->add();
	
		$this->callSubAction('listing');
	}


	// Speichern eines Modells
	function save()
	{
		if   ( $this->getRequestVar('name') != '' )
		{
			if   ( $this->getRequestVar('delete') != '' )
			{
				$this->model->delete();

				$this->callSubAction('listing');
			}
			else
			{
				$this->model->name = $this->getRequestVar('name');
				$this->model->save();
				
				$this->callSubAction('listing');
			}
		}
	
		// Baum aktualisieren
		$this->setTemplateVar('tree_refresh',true);

		$this->callSubAction('listing');
	}


	function setdefault()
	{
		if	( !$this->userIsAdmin() ) exit();

		$this->model->setDefault();
	
		$this->callSubAction('listing');
	}


	function listing()
	{
		global $conf_php;
		$actModel = Session::getProjectModel();

//		$var['act_modelid'] = $this->getSessionVar('modelid');
	
		$list = array();
		foreach( $this->project->getModelIds() as $id )
		{
			$m = new Model( $id );
			$m->load();

			$list[$id]['name'] = $m->name;
			
			if	( $this->userIsAdmin() )
				$list[$id]['url' ] = Html::url('model','edit',$id);

			if	( ! $m->isDefault && $this->userIsAdmin() )
				$list[$id]['default_url'] = Html::url('model','setdefault',$id);

			if	( $actModel->modelid != $m->modelid )
				$list[$id]['select_url' ] = Html::url('index','model',$id);
		}
		$this->setTemplateVar( 'el',$list );
		$this->setTemplateVar( 'add',$this->userIsAdmin() );
	
		$this->forward('model_list');
	}


	function edit()
	{
		if   ( count( $this->model->getAll() ) >= 2 )
			$this->setTemplateVar('delete',true );
		else	$this->setTemplateVar('delete',false);

		$this->model->load();
	
		$this->setTemplateVars( $this->model->getProperties() );
	
		$this->forward('model_edit');
	}
}